public class Dado {
	
	private int val;
	
	public Dado() { val=1; }
	
	// NB: Math.random() restituisce un valore double positivo in (0.0, 1.0)
	public void lancio() {
		val = (1+(int)(Math.random()*6));
	}
	
	public int get(){ return val; }
	
	public boolean equals(Object obj) {
	  if (obj == null) return false;
	  if(! (obj instanceof Dado)) return false;
	  else return (val==((Dado)obj).val);
	}
	
	public String toString(){ return "Dado: " + val; }
	
}//end-class-Dado
