/*
ESERCIZIO 2
Definire un'interfaccia "operazione" e le sue classi
derivate (add, sub, div, mul) in modo che da ciascuna sia possibile
eseguire la corrispondente operazione aritmetica
(di addizione, sottrazione, divisione, moltiplicazione) istanziando un
oggetto della classe e due operandi.
Realizzare anche una classe astratta che implementi
le funzionalit comuni come la stampa a video del risultato. 

EXERCISE 2
Define an interface "operation" and four classes (add, sub, div, mul)
implementing "operation" so that each of them can perform the corresponding
arithmetic operation  (addition, subtraction, division, multiplication)
instantiating an object and two operands.
Realize also an abstract class that implements common features such as
printing the result.
 */


interface operazione{
	void ritorno(int a, int b);
}

abstract class stampa{
	//stampa a video del risultato dell'operazione
	public void print(int a, int b, int r, char op){
    	System.out.println(a + " " + op + " " + b + " = " + r);}
}


class add extends stampa implements operazione{
	
	public void ritorno(int a, int b) {
		print(a,b,a+b,'+');
	}
}//end-class add

class sub extends stampa implements operazione{
	
	public void ritorno(int a, int b) { 
		print(a,b,a-b,'-');
	}
} //end-class sub

class div extends stampa implements operazione{

	public void ritorno(int a, int b) { 
		if (b==0) System.out.println(a + "/" + b + " La divisione per zero e' proibita!");
		else print(a,b,a/b,'/'); 
	}
}//end-class div

class mul extends stampa implements operazione{

	public void ritorno(int a, int b) {
		print(a,b,a*b,'*'); 
	}
} //end-class mul


